   import java.awt.Color;
   public class DarterFish extends Fish
   {
      public DarterFish(Environment env, Location loc)
      {
         super(env, loc, env.randomDirection(), Color.yellow);
      }
      public DarterFish(Environment env, Location loc, Direction dir)
      {
         super(env, loc, dir, Color.yellow);
      }
      public DarterFish(Environment env, Location loc, Direction dir, Color col)
      {
         super(env, loc, dir, col);
      }
      protected void generateChild(Location loc)
      {
         DarterFish child = new DarterFish(environment(), loc,
                           environment().randomDirection(),
                           color());
         Debug.println("  New DarterFish created: " + child.toString());
      }
      protected void move()
      {
         Debug.print("DarterFish " + toString() + " attempting to move.  ");
         Location nextLoc = nextLocation();
      
         if(!nextLoc.equals(location()))
         {
            changeLocation(nextLoc);
            Debug.println("  Moves to " + location());
         }
         else
         {
            changeDirection(direction().reverse());
            Debug.println("  Now facing " + direction());
         }
      }
      protected Location nextLocation()
      {
         Environment env = environment();
         Location oneInFront = env.getNeighbor(location(), direction());
         Location twoInFront = env.getNeighbor(oneInFront, direction());
         Debug.println("  Location in front is empty? " + 
                      env.isEmpty(oneInFront));
         Debug.println("  Location in front of that is empty? " + 
                      env.isEmpty(twoInFront));
         if(env.isEmpty(oneInFront))
         {
            if(env.isEmpty(twoInFront))
               return twoInFront;
            else
               return oneInFront;
         }
         Debug.println("  Darter is blocked.");
         return location();
      }
   }