   import java.util.ArrayList;
   public interface Environment
   {
      int numRows();
      int numCols();
      boolean isValid(Location loc);
      int numCellSides();
      int numAdjacentNeighbors();
      Direction randomDirection();
      Direction getDirection(Location fromLoc, Location toLoc);
      Location getNeighbor(Location fromLoc, Direction compassDir);
      ArrayList neighborsOf(Location ofLoc);
      int numObjects();
      Locatable[] allObjects();
      boolean isEmpty(Location loc);
      Locatable objectAt(Location loc);
      void add(Locatable obj);
      void remove(Locatable obj);
      void recordMove(Locatable obj, Location oldLoc);
   }